using System;
using System.Globalization;
using com.agilefaqs.rft.domain;

namespace com.agilefaqs.rft.suggestions.strategies
{
    public abstract class AbstractChildStrategy : ChildSuggestionStrategy
    {
        private readonly UserService userService;

        private readonly SuggestionsUtil utils;

        public AbstractChildStrategy(UserService userService, SuggestionsUtil utils)
        {
            this.userService = userService;
            this.utils = utils;
        }

        protected virtual String getIdentity(String token1, String token2)
        {
            IDTokens IdTokens = utils.getIdentityTokens(token1, token2);
            if (IdTokens == null)
            {
                return null;
            }
            String Identity = utils.appendTokensForId(IdTokens.Token1, IdTokens.Token2);
            if (userService.isIdentityAvailable(Identity))
            {
                return Identity;
            }
            else
            {
                return null;
            }
        }

        protected virtual String currentYear()
        {
            return
                Convert.ToString(
                    SupportClass.CalendarManager.manager.Get(new GregorianCalendar(), SupportClass.CalendarManager.YEAR));
        }

        public abstract String generateId(ChildStrategyParam param1);
    }
}