/// <summary> </summary>
using System;
using System.Collections.Generic;
using com.agilefaqs.rft.suggestions.strategies;

namespace com.agilefaqs.rft.suggestions
{
    public class IdentitySuggestionOneStrategy : SuggestionStrategy
    {
        private readonly List<ChildSuggestionStrategy> childStrategies;

        public IdentitySuggestionOneStrategy(ChildSuggestionFactory childSuggestionFactory)
        {
            childStrategies = childSuggestionFactory.getChildStrategiesForSuggestionOne();
        }

        public virtual String getIdentity(SuggestionParam suggestionParams)
        {
            ChildStrategyParam childParam =
                new ChildStrategyParam(suggestionParams.ValidFirstNameToken, suggestionParams.ValidLastNameToken, null);
            foreach (ChildSuggestionStrategy strategy in childStrategies)
            {
                String Identity = strategy.generateId(childParam);
                if (Identity != null)
                {
                    return Identity;
                }
            }
            return null;
        }
    }
}